#ifndef __MAKET_TCP_H__
#define __MAKET_TCP_H__

#include "../util/config.h"

class EthernetMaketClient : public EthernetClient
{
protected:
    uint32_t lastActivityTime = 0; // Время последней активности
    const uint16_t timeout = 300;  // Таймаут неактивности в миллисекундах
    uint32_t startConnection = 0;
    const uint16_t connectionTimeout = 350;
    uint32_t stopStartTime = 0;       // Время начала состояния CONNECT_IDLE
    const uint32_t stopTimeout = 300; // Таймаут для закрытия сокета в состоянии CONNECT_IDLE

    bool isNonBlocking = true; // Флаг для определения режима подключения
    ConnectionStatusSimple connectStatus = CONNECT_IDLE;

public:
    using EthernetClient::EthernetClient;

    ConnectionStatusSimple connectNonBlock(IPAddress ip, uint16_t port);
    // void stop() override;
    void disconnect();
    void close();
    void tick();
};
#endif // __MAKET_TCP_H__